/****************************************************************************************************************************
**                                                                                                                         **
**                 Copyright (C) 1999 by Punk Productions Electronic Entertainment. All Rights Reserved.                   ** 
**                                                                                                                         **
**        Purpose: Everyone out there should be able to load different Imagefileformats...                                 **
**     Programmer: Nikolaus Brennig, 18, (Nikolaus.Brennig@nol.at)                                                         **
**                 Original ImageLoaderDLL coded by K. Nishita in 1997. I Only used it and created a simple DDloader       **
**                 for it. If you look in the code, its rather easy to use the Loadroutines for standard Win32Apps,        **
**                 since the Data is blitted to a DC, so do what you want with this code.                                  **
**                                                                                                                         **
**                 WARNING: If you want to use this code in a commercial product (game or whatever) you will have          **
**                 to send us ( Nishita and me, nick ) a free and full functional copy of it. Yep, thats business ;-)      **
**                 If you want to use this code only for learning or simply non-commercial use, simply send us an email    **
**                 cause for sure we want to know who out there uses this code...                                          **
**                                                                                                                         **
**                 You can contact us:       Nick: virtualnik@nol.at, http://cust.nol.at/ppee                              **
**                                     K. Nishita: knishita@ibm.net, http://freeware.freeservers.com                       **
**                                                                                                                         **
**                 Ok, thats all for now, so have fun with loading images ;-)                                              **
**                                                                                                                         **
**     Day created: January 12th, 1999                                                                                     **
**                                                                                                                         **
****************************************************************************************************************************/

// Headerfile...
#define WIN32_LEAN_AND_MEAN
#include "DDload.h" 


/*
** This is a very important function. Here the bitmaps and fonts.. wahtever are drawn onto the backbuffer.
*/
void bltObject( int x, int y, LPDIRECTDRAWSURFACE surf, LPRECT src, DWORD flags )
{
    HRESULT ddrval;

    while( 1 )
    {
        ddrval = lpDDSBack->BltFast( x, y, surf, src, flags );
        if( ddrval == DD_OK ) return;
        if( ddrval == DDERR_SURFACELOST ) return;
        if( ddrval != DDERR_WASSTILLDRAWING ) return;
    }
} /* bltObject */

/*
** Another very important function: Here the whole content of the backbuffer is flipped to the primary surface.
** Why? To see something on the screen...
*/
void Flipscreen()
{
  HRESULT  ddrval;
  
    while( 1 )
    {
     ddrval = lpDDSPrimary->Flip( NULL, 0 );
     if( ddrval == DD_OK ) break; 
     if( ddrval == DDERR_SURFACELOST ) break; 
     if( ddrval != DDERR_WASSTILLDRAWING ) break; 
    }
} /* Flipscreen */

/*
** This function paints the Background...
*/
void PaintImages()
{
 RECT rcSrc;

  rcSrc.left = 0; rcSrc.right  = 300;
  rcSrc.top  = 0; rcSrc.bottom = 100;
  bltObject( 0,   30,  lpDDSBMP, &rcSrc, DDBLTFAST_NOCOLORKEY );
  bltObject( 320, 30,  lpDDSDIB, &rcSrc, DDBLTFAST_NOCOLORKEY );
  bltObject( 0,   140, lpDDSGIF, &rcSrc, DDBLTFAST_NOCOLORKEY );
  bltObject( 320, 140, lpDDSJPG, &rcSrc, DDBLTFAST_NOCOLORKEY );
  bltObject( 0,   250, lpDDSTGA, &rcSrc, DDBLTFAST_NOCOLORKEY );
  bltObject( 320, 250, lpDDSPCX, &rcSrc, DDBLTFAST_NOCOLORKEY );
} /* PaintSpace */

// Draw some text with GDI...
void Text( int x, int y, char *words, COLORREF Color )
{
 SetTextColor( hdc, Color );
 TextOut( hdc, x, y, words, lstrlen(words) );
}

/*
** This functions handles the whole app after intialization is done. What to paint, to do....
*/
void HeartBeat( void )
{

 switch( ProgramState )
    {
     // ok, go through the initialization of the app...
     case PS_INITAPP: 
        TextX = 240;
        TextLeft = TRUE;
        ProgramState = PS_ACTIVE;
       return;
     // ok, all works, so tell the stupid pc what to do...
     case PS_ACTIVE:
        // Do the Background...
        PaintImages();
        // Paint our great message and move it too...
        if( TextLeft == FALSE ) { if(TextX<480) { TextX += 1; } }
        if( TextLeft == TRUE  ) { if(TextX>10)  { TextX -= 1; } }
        if( TextX > 475 || TextX < 15) { TextLeft = !TextLeft; }
        if (lpDDSBack->GetDC(&hdc) == DD_OK)
        {
         SetBkMode(hdc, TRANSPARENT);
         SetBkColor( hdc, RGB( 0, 0, 0) );
         Text( TextX, 280, EX3Msg, RGB(0,0,0));
         Text( 60, 380, "This sample was brought to you by Punk Productions Electronic Entertainment!", RGB( 255, 0, 0 ) );
         Text( 210, 400, "Check out http://cust.nol.at/ppee!", RGB( 255, 0, 0 ) );
         Text( 280, 455, "Esc/F12: Quit", RGB( 255, 255, 255 ) );
         lpDDSBack->ReleaseDC(hdc);
        }
        // Flip the Backbuffer to the primary surface so you can see it...
        Flipscreen();
       return;
    }
} /* HeartBeat */

/*
** A standard winprocedure. Here you can set keyhandling or whatever...it's the main message handler
*/
long FAR PASCAL WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

   switch( message )
    {
    case WM_ACTIVATEAPP:
         bActive = wParam;
        break;

    case WM_SETCURSOR:
         SetCursor(NULL);
        return TRUE;

    case WM_KEYDOWN:
        switch( wParam )
        {
         case VK_ESCAPE: PostMessage(hWnd, WM_CLOSE, 0, 0); break;
        }
        break;

    case WM_DESTROY:   
        finiObjects();  // Delete the objects...
        ReleaseImageViewerDLL();
        PostQuitMessage( 0 ); 
        break;

    }

    return DefWindowProc(hWnd, message, wParam, lParam);

} /* WindowProc */

/*
** Get the surfaces out of memory...
*/
#define RELEASE(x) if( x != NULL ) { x->Release(); x = NULL; }
void finiObjects( void )
{
    if( lpDD != NULL )
    {
        RELEASE( lpDDSPrimary );
        RELEASE( lpDDSBMP );
        RELEASE( lpDDSDIB );
        RELEASE( lpDDSGIF );
        RELEASE( lpDDSJPG );
        RELEASE( lpDDSTGA );
        RELEASE( lpDDSPCX );
        lpDD->Release();
        lpDD = NULL;
    }
} /* finiObjects */



